Index: code/branches/presentation3/data/levels/Level(Deathmatch).oxw
===================================================================
--- code/branches/presentation3/data/levels/Level(Deathmatch).oxw	(revision 6934)
+++ code/branches/presentation3/data/levels/Level(Deathmatch).oxw	(revision 6935)
@@ -60,4 +60,7 @@
   gametype=TeamDeathmatch
 >
+    <lodinformation>
+	    <MeshLodInformation mesh=Transporter.mesh lodQuality=10 />
+    </lodinformation>
 
 	<!-- Ausgang: Szene ===> ambientlight/skybox -->
@@ -82,5 +85,16 @@
 
 		<!--Spieler Spawnpoint ===> position/direction-->
-		<SpawnPoint position="150,0,-50" direction="2000,0,-1000" spawnclass=SpaceShip pawndesign=spaceshipassffplayer team=0 active="true" > 
+		<SpawnPoint position="150,0,-50" direction="2000,0,-1000" spawnclass=SpaceShip pawndesign=spaceshipassffplayer team=0 active="true" name=spawn1> 
+			<events>
+				<activity>
+					<EventListener event="activateFirstSpawnpoint" />
+				</activity>
+			</events>
+			<attached>
+			    <Billboard position="0,0,0" colour="0,1.0,0" material="Examples/Flare"/>
+			</attached>
+		</SpawnPoint>
+
+		<SpawnPoint position="10000,0,3000" direction="2000,0,-1000" spawnclass=SpaceShip pawndesign=spaceshipassffplayer team=0 active="false" name=spawn2> 
 			<events>
 				<activity>
@@ -88,12 +102,7 @@
 				</activity>
 			</events>
-		</SpawnPoint>
-
-		<SpawnPoint position="10000,0,3000" direction="2000,0,-1000" spawnclass=SpaceShip pawndesign=spaceshipassffplayer team=0 active="false" > 
-			<events>
-				<activity>
-					<EventListener event="activateSecondSpawnpoint" />
-				</activity>
-			</events>
+			<attached>
+			    <Billboard position="0,0,0" colour="1.0,0,0" material="Examples/Flare"/>
+			</attached>
 		</SpawnPoint>
 
@@ -231,23 +240,19 @@
 <!--Erstellen des Asteroidenfeldes___FUNKTIONIERT_________________________________________________________________________________________________________________________________________OK--> 
 
-		<StaticEntity position="3000,0,-1000">
+		<?lua for i=0,100,1 do 
+		x=math.random(250,4000)
+		y=math.random(-500,500)
+		z=math.random(1000,2000)
+		scale=math.random(20,70)
+		?>
+		<MovableEntity collisionType=kinematic linearDamping=0.8 angularDamping=0 mass="<?lua print(scale * 5) ?>" position="<?lua print(x) ?>,<?lua print(y) ?>,<?lua print(z) ?>" rotationaxis="<?lua print(math.random()) ?>,<?lua print(math.random()) ?>,<?lua print(math.random()) ?>" rotationrate="<?lua print(math.random()*15) ?>">
 			<attached>
-				<?lua for i=0,100,1 do 
-				x=math.random(250,4000)
-				y=math.random(-500,500)
-				z=math.random(1000,2000)
-				scale=math.random(20,70)
-				?>
-				<MovableEntity collisionType=kinematic linearDamping=0.8 angularDamping=0 mass="<?lua print(scale * 5) ?>" position="<?lua print(x) ?>,<?lua print(y) ?>,<?lua print(z) ?>" rotationaxis="<?lua print(math.random()) ?>,<?lua print(math.random()) ?>,<?lua print(math.random()) ?>" rotationrate="<?lua print(math.random()*15) ?>">
-					<attached>
-						<Model scale=<?lua print(scale) ?> mesh="ast<?lua print( math.mod(i,6) + 1) ?>.mesh" shadow=false/>
-					</attached>
-					<collisionShapes>
-        				<SphereCollisionShape radius="<?lua print(scale * 3) ?>" />
-      					</collisionShapes> 
-				</MovableEntity>
-				<?lua end ?>
+				<Model scale=<?lua print(scale) ?> mesh="ast<?lua print( math.mod(i,6) + 1) ?>.mesh" shadow=false/>
 			</attached>
-		</StaticEntity>
+			<collisionShapes>
+				<SphereCollisionShape radius="<?lua print(scale * 3) ?>" />
+				</collisionShapes> 
+		</MovableEntity>
+		<?lua end ?>
 
 <!--Erstellen des Ateroidenfeldes______ENDE__________________________________________________________________________________________________________________________________________________-->
@@ -255,22 +260,18 @@
 <!--Erstellen von Asteroiden die zufaellig plaziert sind___________________________________________________________________________________________________________________________________OK-->
 
-		<StaticEntity position="0,0,0">
-			<attached>
-				<?lua for i=0,150,1 do 
-				x=math.random(-8000,8000)
-				y=math.random(-8000,8000)
-				z=math.random(-8000,8000)
-				?>
-				<MovableEntity collisionType=kinematic linearDamping=0.8 angularDamping=0 mass="<?lua print(scale * 5) ?>" position="<?lua print(x) ?>,<?lua print(y) ?>,<?lua print(z) ?>" rotationaxis="<?lua print(math.random()) ?>,<?lua print(math.random()) ?>,<?lua print(math.random()) ?>" rotationrate="<?lua print(math.random()*15) ?>" >
-					<attached>
-						<Model scale=<?lua print(math.random(20,70)) ?> mesh="ast<?lua print( math.mod(i,6) + 1) ?>.mesh" shadow=false/>
-					</attached>
-					<collisionShapes>
-       					<SphereCollisionShape radius="<?lua print(scale * 3) ?>" />
- 					</collisionShapes> 
-				</MovableEntity>
-				<?lua end ?>
-			</attached>
-		</StaticEntity>
+	<?lua for i=0,150,1 do 
+	x=math.random(-8000,8000)
+	y=math.random(-8000,8000)
+	z=math.random(-8000,8000)
+	?>
+	<MovableEntity collisionType=kinematic linearDamping=0.8 angularDamping=0 mass="<?lua print(scale * 5) ?>" position="<?lua print(x) ?>,<?lua print(y) ?>,<?lua print(z) ?>" rotationaxis="<?lua print(math.random()) ?>,<?lua print(math.random()) ?>,<?lua print(math.random()) ?>" rotationrate="<?lua print(math.random()*15) ?>" >
+		<attached>
+			<Model scale=<?lua print(math.random(20,70)) ?> mesh="ast<?lua print( math.mod(i,6) + 1) ?>.mesh" shadow=false/>
+		</attached>
+		<collisionShapes>
+			<SphereCollisionShape radius="<?lua print(scale * 3) ?>" />
+		</collisionShapes> 
+	</MovableEntity>
+	<?lua end ?>
 
 <!--Erstellen von Asteroiden die zufaellig plaziert sind______ENDE___________________________________________________________________________________________________________________________-->
@@ -405,5 +406,11 @@
 <!--Erstellen von Feinden auf dem Weg zu den Transportern______ENDE__________________________________________________________________________________________________________________________-->
 
-<DistanceTrigger name="activateSecondSpawnpoint" position="10000,0,3000" distance="1000" target="DistanceTriggerBeacon" targetname="PlayerDistanceTrigger" activations="1" stayactive="true" />
+<Trigger name=activateFirstSpawnpoint invert=true >
+    <DistanceTrigger name="activateSecondSpawnpoint" position="150,0,-300" distance="10" target="DistanceTriggerBeacon" targetname="PlayerDistanceTrigger" activations="1" stayactive="true">
+        <attached>
+                <Billboard position="0,0,0" colour="0,0,1.0" material="Examples/Flare" />
+        </attached>
+    </DistanceTrigger>
+</Trigger>
 
 	</Scene>
Index: code/branches/presentation3/src/modules/objects/triggers/DistanceTrigger.cc
===================================================================
--- code/branches/presentation3/src/modules/objects/triggers/DistanceTrigger.cc	(revision 6934)
+++ code/branches/presentation3/src/modules/objects/triggers/DistanceTrigger.cc	(revision 6935)
@@ -155,4 +155,5 @@
       }
     }
+
     return false;
   }
Index: code/branches/presentation3/src/modules/questsystem/QuestEffectBeacon.cc
===================================================================
--- code/branches/presentation3/src/modules/questsystem/QuestEffectBeacon.cc	(revision 6934)
+++ code/branches/presentation3/src/modules/questsystem/QuestEffectBeacon.cc	(revision 6935)
@@ -134,5 +134,5 @@
         if(pawn == NULL)
         {
-            COUT(2) << "The QuestEffectBeacon was triggered by an entity other than a Pawn." << std::endl;
+            COUT(2) << "The QuestEffectBeacon was triggered by an entity other than a Pawn. (" << trigger->getIdentifier()->getName() << ")" << std::endl;
             return false;
         }
Index: code/branches/presentation3/src/orxonox/gametypes/TeamDeathmatch.cc
===================================================================
--- code/branches/presentation3/src/orxonox/gametypes/TeamDeathmatch.cc	(revision 6934)
+++ code/branches/presentation3/src/orxonox/gametypes/TeamDeathmatch.cc	(revision 6935)
@@ -138,9 +138,9 @@
 
         SpawnPoint* fallbackSpawnPoint = NULL;
-
         if (teamSpawnPoints.size() > 0)
         {
             unsigned int randomspawn = static_cast<unsigned int>(rnd(static_cast<float>(teamSpawnPoints.size())));
             unsigned int index = 0;
+            // Get random fallback spawnpoint in case there is no active SpawnPoint.
             for (std::set<SpawnPoint*>::const_iterator it = teamSpawnPoints.begin(); it != teamSpawnPoints.end(); ++it)
             {
@@ -154,15 +154,19 @@
             }
 
+            // Remove all inactive SpawnPoints from the list.
             for (std::set<SpawnPoint*>::const_iterator it = teamSpawnPoints.begin(); it != teamSpawnPoints.end(); )
             {
-                if (!(*it)->isActive())
-                {
-                    COUT(1) << "MUP" << std::endl;
+                if(!(*it)->isActive())
+                {
+                    COUT(1) << (*it)->getName() << " is inactive." << std::endl;
                     teamSpawnPoints.erase(it++);
                     continue;
                 }
+                COUT(1) << (*it)->getName() << " is active." << std::endl;
 
                 ++it;
             }
+
+            COUT(1) << "MUP " << teamSpawnPoints.size() << std::endl;
 
             randomspawn = static_cast<unsigned int>(rnd(static_cast<float>(teamSpawnPoints.size())));