Index: branches/spaceshipcontrol/src/world_entities/space_ships/helicopter.cc
===================================================================
--- branches/spaceshipcontrol/src/world_entities/space_ships/helicopter.cc	(revision 6935)
+++ branches/spaceshipcontrol/src/world_entities/space_ships/helicopter.cc	(revision 6936)
@@ -10,5 +10,5 @@
 
 ### File Specific:
-   main-programmer: Benjamin Grauer
+   main-programmer: Benjamin Knecht
    co-programmer: ...
 
@@ -93,6 +93,4 @@
   this->addWeapon(cannon, 0, 6);
 
-  //this->addWeapon(turret, 3, 0);
-
   this->getWeaponManager()->changeWeaponConfig(1);
   dynamic_cast<Element2D*>(this->getWeaponManager()->getFixedTarget())->setVisibility( false);
@@ -105,5 +103,4 @@
 void Helicopter::init()
 {
-//  this->setRelDir(Quaternion(M_PI, Vector(1,0,0)));
   this->setClassID(CL_HELICOPTER, "Helicopter");
 
@@ -120,14 +117,11 @@
   controlVelocityX = 100;
   controlVelocityY = 100;
-  //rotorspeed = 1;
-  //tailrotorspeed = 0;
-
-  //cycle = 0.0;
-
-  // cameraissue
+
+
+  // initialization of cameraNode
   this->cameraNode.setParent(this);
   this->cameraNode.setParentMode(PNODE_ALL);
-
-
+  this->cameraNode.setRelCoor(Vector(0,1,0));
+  
   // rotors
   this->topRotor.addNodeFlags(PNODE_PROHIBIT_DELETE_WITH_PARENT);
@@ -145,11 +139,12 @@
 
 
-  //travelSpeed = 15.0;
   this->velocity = Vector(0.0,0.0,0.0);
   this->velocityDir = Vector(1.0,0.0,0.0);
-//   GLGuiButton* button = new GLGuiPushButton();
-//   button->show();
-//   button->setLabel("orxonox");
-//   button->setBindNode(this);
+  
+  // very, very old stuff
+  //  GLGuiButton* button = new GLGuiPushButton();
+  //  button->show();
+  //  button->setLabel("orxonox");
+  //  button->setBindNode(this);
 
   //add events to the eventlist
@@ -158,5 +153,4 @@
   registerEvent(KeyMapper::PEV_LEFT);
   registerEvent(KeyMapper::PEV_RIGHT);
-  //registerEvent(SDLK_q);
   registerEvent(SDLK_e);
   registerEvent(SDLK_c);
@@ -164,6 +158,4 @@
   registerEvent(KeyMapper::PEV_NEXT_WEAPON);
   registerEvent(KeyMapper::PEV_PREVIOUS_WEAPON);
-  //registerEvent(SDLK_PAGEUP);
-  //registerEvent(SDLK_PAGEDOWN);
   registerEvent(EV_MOUSE_MOTION);
 
@@ -187,13 +179,7 @@
   this->getWeaponManager()->setSlotPosition(5, Vector(-1.5, -.5, -.5));
   this->getWeaponManager()->setSlotDirection(5, Quaternion(+M_PI_4*.5-M_PI, Vector(1,0,0)));
-//
-   this->getWeaponManager()->setSlotPosition(6, Vector(-1, 0.0, 0));
-   this->getWeaponManager()->setSlotCapability(6, WTYPE_ALLDIRS | WTYPE_DIRECTIONAL);
-   //
-//   this->getWeaponManager()->setSlotPosition(8, Vector(-2.5, -0.3, -2.0));
-//   this->getWeaponManager()->setSlotDirection(8, Quaternion(-M_PI, Vector(1,0,0)));
-//
-//   this->getWeaponManager()->setSlotPosition(9, Vector(-2.5, -0.3, 2.0));
-//   this->getWeaponManager()->setSlotDirection(9, Quaternion(+M_PI, Vector(1,0,0)));:
+
+  this->getWeaponManager()->setSlotPosition(6, Vector(-1, 0.0, 0));
+  this->getWeaponManager()->setSlotCapability(6, WTYPE_ALLDIRS | WTYPE_DIRECTIONAL);
 
   this->getWeaponManager()->getFixedTarget()->setParent(&(this->cameraNode));
@@ -282,26 +268,11 @@
   if(velocity.len() != 0) velocity -= velocity*0.1;
 
-  //travelSpeed = velocity.len();
-
-  //physics: Gravity
-  /*this->shiftCoor(Vector(0,-1,0));
-
-  this->shiftCoor(getAbsDirY()*rotorspeed);
-  */
-
-  /*
-  //hoover effect
-  cycle += time;
-  this->shiftCoor(Vector(0,1,0)*cos(this->cycle*2.0)*0.02);
-  */
 
   //readjust
- // if (this->getAbsDirZ().y > 0.1) this->shiftDir(Quaternion(time*0.3, Vector(1,0,0)));
-  //else if (this->getAbsDirZ().y < -0.1) this->shiftDir(Quaternion(-time*0.3, Vector(1,0,0)));
-
-  //SDL_WarpMouse(GraphicsEngine::getInstance()->getResolutionX()/2, GraphicsEngine::getInstance()->getResolutionY()/2);
+  // if (this->getAbsDirZ().y > 0.1) this->shiftDir(Quaternion(time*0.3, Vector(1,0,0)));
+  // else if (this->getAbsDirZ().y < -0.1) this->shiftDir(Quaternion(-time*0.3, Vector(1,0,0)));
+
 
   this->shiftCoor (move);
-  //this->shiftDir(Quaternion(-M_PI/4*tailrotorspeed, Vector(0,1,0)));
 }
 
@@ -344,5 +315,5 @@
    }
 
-  if( this->bLeft /* > -this->getRelCoor().z*2*/)
+  if( this->bLeft )
   {
     //this->shiftDir(Quaternion(time, Vector(0,1,0)));
@@ -358,5 +329,5 @@
    }
 
-  if( this->bRight /* > this->getRelCoor().z*2*/)
+  if( this->bRight )
   {
     //this->shiftDir(Quaternion(-time, Vector(0,1,0)));
@@ -372,51 +343,20 @@
    }
 
-  if( this->bRollL /* > -this->getRelCoor().z*2*/)
+  if( this->bRollL )
   {
     this->shiftDir(Quaternion(-time, Vector(1,0,0)));
-    //accel -= rightDirection;
-    //velocityDir.normalize();
-    //rot +=Vector(1,0,0);
-    //rotVal -= .4;
-  }
-  if( this->bRollR /* > this->getRelCoor().z*2*/)
+  }
+  if( this->bRollR )
   {
     this->shiftDir(Quaternion(time, Vector(1,0,0)));
-
-    //accel += rightDirection;
-    //velocityDir.normalize();
-    //rot += Vector(1,0,0);
-    //rotVal += .4;
   }
   if (this->bAscend )
   {
-    //this->shiftDir(Quaternion(time, Vector(0,0,1)));
-
     accel += this->getAbsDirY();
-    //rotorspeed += 0.05;
-    //if (rotorspeed >= 2) rotorspeed = 2;
-    //velocityDir.normalize();
-    //rot += Vector(0,0,1);
-    //rotVal += .4;
-  }
-  else
-  {
-    //if(rotorspeed >= 1.05) rotorspeed -= 0.05;
   }
 
   if (this->bDescend )
   {
-    //this->shiftDir(Quaternion(-time, Vector(0,0,1)));
-
     accel -= this->getAbsDirY();
-    //rotorspeed -= 0.05;
-    //if (rotorspeed <= 0) rotorspeed = 0;
-    //velocityDir.normalize();
-    //rot += Vector(0,0,1);
-    //rotVal -= .4;
-  }
-  else
-  {
-    //if(rotorspeed <= 0.05) rotorspeed += 0.05;
   }
 
@@ -468,11 +408,11 @@
       this->bRight = event.bPressed;
   else if( event.type == SDLK_e)
-    this->bAscend = event.bPressed; //this->shiftCoor(0,.1,0);
+    this->bAscend = event.bPressed;
   else if( event.type == SDLK_c)
-    this->bDescend = event.bPressed; //this->shiftCoor(0,-.1,0);
+    this->bDescend = event.bPressed;
   else if( event.type == KeyMapper::PEV_UP)
-    this->bUp = event.bPressed; //this->shiftCoor(0,.1,0);
+    this->bUp = event.bPressed;
   else if( event.type == KeyMapper::PEV_DOWN)
-    this->bDown = event.bPressed; //this->shiftCoor(0,-.1,0);
+    this->bDown = event.bPressed;
   else if( event.type == EV_MOUSE_MOTION)
   {
Index: branches/spaceshipcontrol/src/world_entities/space_ships/helicopter.h
===================================================================
--- branches/spaceshipcontrol/src/world_entities/space_ships/helicopter.h	(revision 6935)
+++ branches/spaceshipcontrol/src/world_entities/space_ships/helicopter.h	(revision 6936)
@@ -55,12 +55,11 @@
     int                   yInvert;
     float                 mouseSensitivity;   //!< the mouse sensitivity
-    int                   controlVelocityX;
-    int                   controlVelocityY;
-    //float                 cycle;              //!< hovercycle
+    int                   controlVelocityX;   //!< defines max velocity of Xaxis of mousecontrol
+    int                   controlVelocityY;   //!< defines max velocity of Yaxis of mousecontrol
 
-    PNode                 topRotor;
-    PNode                 tailRotor;
+    PNode                 topRotor;           //!< the position of the toprotor
+    PNode                 tailRotor;          //!< the position of the tailrotor
 
-    PNode                 cameraNode;
+    PNode                 cameraNode;         //!< the position the camera is locked at (used to look up and down without turning the helicopter)
 
     Vector                velocity;           //!< the velocity of the player.
@@ -68,6 +67,4 @@
     float                 travelSpeed;        //!< the current speed of the player (to make soft movement)
     float                 acceleration;       //!< the acceleration of the player.
-    //float                 rotorspeed;         //!< the speed of the rotor.
-    //float                 tailrotorspeed;     //!< the relativ speed ot the tail rotor
 
     float                 airViscosity;